
//
//	Nev@Delap.com, October 2000
//

#include "stdafx.h"
#include "DialogConverter.h"

#include "ObjModel\AppGuid.h"
#include "ObjModel\TextGuid.h"

									// Dodgy Brothers conversions.
									// Feel free to do the conversion properly.
const double dDLUS_TO_PIXELS_LEFT_FACTOR=1.500;
const double dDLUS_TO_PIXELS_TOP_FACTOR=1.600;
const double dDLUS_TO_PIXELS_WIDTH_FACTOR=1.500;
const double dDLUS_TO_PIXELS_HEIGHT_FACTOR=1.690;

//////////////////////////////////////

void DialogConverter::ConvertOpenDialogToClassSourceInIDE(
					IApplication* pIApplication)
{
	CString strDialogResourceName;
	CString strDefinition;
	CString strSource;
	CString strClassName;
	
	GetCurrentlyOpenDialogsDefinitionFromIDE(pIApplication,strDialogResourceName,strDefinition);
	ConvertDefinitionToClassSource			(strDialogResourceName,strDefinition,strSource);
	DisplayClassInIDE						(pIApplication,strSource);
}

//////////////////////////////////////

void DialogConverter::GetCurrentlyOpenDialogsDefinitionFromIDE(
					IApplication* pIApplication,
					CString& strDialogResourceName,
					CString& strDefinition)
{
	CString strResourceFile;

	GetResourceFileNameAndDialogResourceName(
									pIApplication,
									strResourceFile,
									strDialogResourceName);

	OpenResourceFileAndGetDialogDefinition(
									pIApplication,
									strResourceFile,
									strDialogResourceName,
									strDefinition);
}

void DialogConverter::GetResourceFileNameAndDialogResourceName(
									IApplication* pIApplication,
									CString& strResourceFile,
									CString& strDialogResourceName)
{
	CString strTitle=GetCurrentWindowsTitle(pIApplication);

	if(strTitle.Right(9)==" (Dialog)" &&
	   strTitle.Find(" -"))
	{
		int iStart=strTitle.Find(" -");

		strResourceFile      =strTitle.Left(iStart);

		iStart+=3;
		int iCount=strTitle.GetLength()-iStart-9;

		strDialogResourceName=strTitle.Mid(iStart,iCount);

									// Not of changed 20 October.
		if(strDialogResourceName.Find(" [")!=-1)
		{
			strDialogResourceName=strDialogResourceName.Left(
										strDialogResourceName.Find(" ["));
		}
									// End of changed 20 October.
	}
	else
	{
		throw CString("Please open a dialog in the dialog editor.");
	}
}

CString DialogConverter::GetCurrentWindowsTitle(IApplication* pIApplication)
{
	CComPtr<IDispatch> pDisp;
	CComPtr<IApplication> pApplication(pIApplication);

	if(SUCCEEDED(pApplication->get_ActiveWindow(&pDisp)))
	{
		CComQIPtr<IGenericWindow, &IID_IGenericWindow> pWindow=pDisp;

		if(pWindow)
		{
			BSTR bstrCaption=NULL;

			if(SUCCEEDED(pWindow->get_Caption(&bstrCaption)))
			{
				CString strCaption=bstrCaption;

				SysFreeString(bstrCaption);

				return strCaption;
			}
		}
	}

	return "";
}

void DialogConverter::OpenResourceFileAndGetDialogDefinition(
									IApplication* pIApplication,
									CString strResourceFile,
									CString strDialogResourceName,
									CString& strDefinition)
{
	CComPtr<IDispatch> pDisp;
	CComPtr<IApplication> pApplication(pIApplication);

	if(SUCCEEDED(pApplication->get_Documents(&pDisp)))
	{
		CComQIPtr<IDocuments, &IID_IDocuments> pDocuments=pDisp;
		pDisp=NULL;

		if(pDocuments)
		{
			if(SUCCEEDED(pDocuments->Open(
										_bstr_t(strResourceFile),
										_variant_t("Text"),
										_variant_t(VARIANT_TRUE),
										&pDisp)))
			{
				CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocument=pDisp;
				pDisp=NULL;

				if(pDocument)
				{
					DsSaveStatus dsSaveStatus;
					if(SUCCEEDED(pDocument->Close(_variant_t(VARIANT_TRUE),&dsSaveStatus)))
					{
						if(SUCCEEDED(pDocuments->Open(
											_bstr_t(strResourceFile),
											_variant_t("Text"),
											_variant_t(VARIANT_TRUE),
											&pDisp)))
						{
							CComQIPtr<ITextDocument, &IID_ITextDocument> pTextDocument=pDisp;
							pDisp=NULL;

							if(pTextDocument)
							{
								if(SUCCEEDED(pTextDocument->get_Selection(&pDisp)))
								{
									CComQIPtr<ITextSelection, &IID_ITextSelection> pSelection=pDisp;
									pDisp=NULL;

									if(pSelection)
									{
										VARIANT_BOOL bFound;

										if(SUCCEEDED(pSelection->FindText(
																	_bstr_t(strDialogResourceName),
																	_variant_t((long)dsMatchForward),
																	&bFound)))
										{
											VERIFY(SUCCEEDED(pSelection->StartOfLine(
																				_variant_t((long)dsFirstColumn),
																				_variant_t((long)dsMove))));

											long lFirstLine;

											VERIFY(SUCCEEDED(pSelection->get_CurrentLine(&lFirstLine)));

											if(SUCCEEDED(pSelection->FindText(
																	_bstr_t("END"),
																	_variant_t((long)dsMatchForward),
																	&bFound)))
											{
												long lLastLine;

												VERIFY(SUCCEEDED(pSelection->get_CurrentLine(&lLastLine)));

												VERIFY(SUCCEEDED(pSelection->WordRight(
																				_variant_t((long)dsMove),
																				_variant_t((1L)))));

												VERIFY(SUCCEEDED(pSelection->LineUp(
																				_variant_t((long)dsExtend),
																				_variant_t(lLastLine-lFirstLine))));

												VERIFY(SUCCEEDED(pSelection->StartOfLine(
																				_variant_t((long)dsFirstColumn),
																				_variant_t((long)dsExtend))));

												BSTR bstrText;

												if(SUCCEEDED(pSelection->get_Text(&bstrText)))
												{
													strDefinition=bstrText;

													SysFreeString(bstrText);
												}
												else
												{
													throw CString("Can't get text of dialog definition.");
												}
											}
										}
									}
								}
							}
						}
					}
					else
					{
						throw CString("Can't close resource file. (It has to be reopened as Text).");
					}
				}
				else
				{
					throw CString("Couldn't open ")+strResourceFile;
				}
			}
			else
			{
				throw CString("Couldn't open ")+strResourceFile;
			}
		}
	}
}

//////////////////////////////////////

void DialogConverter::ConvertDefinitionToClassSource(
							CString strDialogResourceName,
							CString strDefinition,
							CString& strSource)
{
	CString strFields;
	CString strConstructor;

	ConvertDialog(strDialogResourceName,strDefinition,strFields,strConstructor);

	CString strClassName=ConvertDialogResourceNameToFormName(strDialogResourceName);

	strSource=
		"\r\n"
		"//\r\n"
		"// Generated by the NetForm Visual Studio Add-In.\r\n"
		"// Nev Delap, October 2000. Send feedback to Nev@Delap.com\r\n"
		"//\r\n"
		"\r\n"
		"using System;\r\n"
		"using System.Drawing;\r\n"
		"using System.WinForms;\r\n"
		"\r\n"
		"public class "+strClassName+" : Form\r\n"
		"{\r\n"+

		strFields+

		"    \r\n"
		"    public static int Main(string[] Args)\r\n"
		"    {\r\n"
		"        Application.Run(new "+strClassName+"());\r\n"
		"        return 0;\r\n"
		"    }\r\n"+
		"    \r\n"+

		strConstructor+

		"}\r\n";
}

void DialogConverter::ConvertDialog(
								CString strDialogResourceName,
								CString strDefinition,
								CString& strFields,
								CString& strConstructor)
{
	CString strClassName=ConvertDialogResourceNameToFormName(strDialogResourceName);

	Tokenizer tokenizer(strDefinition);

	CString strDialogWidth =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR,5);
	CString strDialogHeight=tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);

									// Changed 20 October.
	CString strCaption;

	CString strToken;
	while((strToken=tokenizer.NextToken())!="CAPTION" &&
		   strToken!="BEGIN" && 
		   strToken!="");

	if(strToken=="")
	{
		AfxMessageBox(
				"The dialog converter didn't find CAPTION or BEGIN "
				"where it expected to. It's probably lost.");
	}
	else if(strToken=="CAPTION")
	{
		strCaption=tokenizer.NextTokenWithoutQuotes();

		while((strToken=tokenizer.NextToken())!="BEGIN" && strToken!="");

		if(strToken!="BEGIN")
		{
			AfxMessageBox(
					"The dialog converter didn't find BEGIN "
					"where it expected to. It's probably lost.");
		}
	}
	else
	{
		strCaption="?";
	}
									// End of changed 20 October.

	strConstructor=
		"    public "+strClassName+"()\r\n"
		"    {\r\n"
		"        Text         =\""+strCaption+"\";\r\n"+
		"        StartPosition=FormStartPosition.WindowsDefaultLocation;\r\n"+
		"        Width        ="+strDialogWidth+"+SystemInformation.FrameBorderSize.Width*2;\r\n"
		"        Height       ="+strDialogHeight+"+SystemInformation.FrameBorderSize.Height*2;\r\n"
		"        BorderStyle  =FormBorderStyle.FixedDialog;\r\n"
		"        MaximizeBox  =false;\r\n"
		"        MinimizeBox  =false;\r\n";

	int iTabIndex=0;

	CString strControl=tokenizer.NextToken();

	while(strControl!="END" && strControl!="")
	{
		CString strTabIndex;
		strTabIndex.Format("%d",iTabIndex++);

		if(strControl=="DEFPUSHBUTTON")
		{
			ConvertButton(tokenizer,strTabIndex,true,strFields,strConstructor);
		}
		else if(strControl=="PUSHBUTTON")
		{
			ConvertButton(tokenizer,strTabIndex,false,strFields,strConstructor);
		}
		else if(strControl=="LTEXT")
		{
			ConvertLabel(tokenizer,strTabIndex,strFields,strConstructor);
		}
		else if(strControl=="EDITTEXT")
		{
			ConvertEditCtrl(tokenizer,strTabIndex,strFields,strConstructor);
		}
		else if(strControl=="CONTROL")
		{
			CString strLabel	=tokenizer.NextToken();
			CString strControlID=tokenizer.NextToken();
			CString strType		=tokenizer.NextToken();
			CString strFlags	=tokenizer.NextToken();

			tokenizer.PushBackToken(strFlags);
			tokenizer.PushBackToken(strType);
			tokenizer.PushBackToken(strControlID);
			tokenizer.PushBackToken(strLabel);

			if(strFlags.Find("BS_AUTOCHECKBOX")!=-1)
			{
				ConvertCheckBox(tokenizer,strTabIndex,strFields,strConstructor);
			}
			else if(strFlags.Find("BS_AUTORADIOBUTTON")!=-1)
			{
				ConvertRadioButton(tokenizer,strTabIndex,strFields,strConstructor);
			}
									// Changed 20 October.
			else if(strFlags.Find("LVS_REPORT")!=-1)
			{
				AfxMessageBox(
				"The dialog being converted contains "
				"a control that this add-in doesn't "
				"support - ListView? Attempting "
				"to skip it.");

				if(tokenizer.NextToken(7)=="")
				{
					break;
				}
			}
			else if(strControlID.Find("SLIDER")!=-1)
			{
				AfxMessageBox(
				"The dialog being converted contains "
				"a control that this add-in doesn't "
				"support - Slider? Attempting "
				"to skip it.");

				if(tokenizer.NextToken(7)=="")
				{
					break;
				}
			}
			else if(strControlID.Find("SPIN")!=-1)
			{
				AfxMessageBox(
				"The dialog being converted contains "
				"a control that this add-in doesn't "
				"support - Spinner? Attempting "
				"to skip it.");

				if(tokenizer.NextToken(7)=="")
				{
					break;
				}
			}						// End of changed 20 October.
			else
			{
				AfxMessageBox(
					"The dialog being converted contains "
					"a control type that this add-in doesn't "
					"support - "+strLabel);

				break;
			}
		}
		else if(strControl=="COMBOBOX")
		{
			ConvertComboBox(tokenizer,strTabIndex,strFields,strConstructor);
		}
		else if(strControl=="LISTBOX")
		{
			ConvertListBox(tokenizer,strTabIndex,strFields,strConstructor);
		}
									// Changed 20 October.
		else if(strControl=="GROUPBOX" ||
				strControl=="ICON" ||
				strControl=="SCROLLBAR")
		{
			AfxMessageBox(
				"The dialog being converted contains "
				"a control that this add-in doesn't "
				"support - "+strControl+". Attempting "
				"to skip it.");

			if(strControl=="GROUPBOX" || strControl=="ICON")
			{
				if(tokenizer.NextToken(5)=="")
				{
					break;
				}
			}
			else if(strControl=="SCROLLBAR")
			{
				if(tokenizer.NextToken(4)=="")
				{
					break;
				}

				CString strTemp;

				if((strTemp=tokenizer.NextToken())!="SBS_VERT")
				{
					tokenizer.PushBackToken(strTemp);
				}
			}
		}							// End of changed 20 October.
		else
		{
			AfxMessageBox(
				"The dialog being converted contains "
				"a control that this add-in doesn't "
				"support - "+strControl);

			break;
		}

		strControl=tokenizer.NextToken();
	}

	strConstructor+=
		"    }\r\n";
}

void DialogConverter::ConvertButton(
								Tokenizer& tokenizer,
								CString strTabIndex,
								bool bIsDefault,
								CString& strFields,
								CString& strConstructor)
{
	CString strLabel   =tokenizer.NextTokenWithoutQuotes();
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"Button","");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR);
	CString strTop	   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);

	strFields+=
		"    private Button "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new Button();\r\n"
		"        "+strVariable+".Text    =\""+strLabel+"\";\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strTop+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";

	if(bIsDefault)
	{
		strConstructor+=
		"        AcceptButton="+strVariable+";\r\n";
	}	
}

void DialogConverter::ConvertLabel(
								Tokenizer& tokenizer,
								CString strTabIndex,
								CString& strFields,
								CString& strConstructor)
{
	CString strLabel   =tokenizer.NextTokenWithoutQuotes();
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"Label","Static");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);
	
	strFields+=
		"    private Label "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new Label();\r\n"
		"        "+strVariable+".Text    =\""+strLabel+"\";\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";

									// Changed 20 October.
	CString strTemp=tokenizer.NextToken();

	if(strTemp=="NOT")
	{
		CString strTemp2=tokenizer.NextToken();

		if(strTemp2!="WS_GROUP")
		{
			tokenizer.PushBackToken(strTemp2);
			tokenizer.PushBackToken(strTemp);
		}
	}
	else
	{
		tokenizer.PushBackToken(strTemp);
	}
									// End of changed 20 October.
}

void DialogConverter::ConvertEditCtrl(
					Tokenizer& tokenizer,
					CString strTabIndex,
					CString& strFields,
					CString& strConstructor)
{
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"TextBox","Edit");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);
	CString strFlags   =tokenizer.NextToken();

	strFields+=
		"    private TextBox "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new TextBox();\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";
}

void DialogConverter::ConvertCheckBox(
					Tokenizer& tokenizer,
					CString strTabIndex,
					CString& strFields,
					CString& strConstructor)
{
	CString strLabel   =tokenizer.NextTokenWithoutQuotes();
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"CheckBox","Check");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR,2);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);

	strFields+=
		"    private CheckBox "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new CheckBox();\r\n"
		"        "+strVariable+".Text    =\""+strLabel+"\";\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";
}

void DialogConverter::ConvertRadioButton(
					Tokenizer& tokenizer,
					CString strTabIndex,
					CString& strFields,
					CString& strConstructor)
{
	CString strLabel   =tokenizer.NextTokenWithoutQuotes();
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"RadioButton","Radio");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR,2);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);

	strFields+=
		"    private RadioButton "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new RadioButton();\r\n"
		"        "+strVariable+".Text    =\""+strLabel+"\";\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";
}

void DialogConverter::ConvertComboBox(
					Tokenizer& tokenizer,
					CString strTabIndex,
					CString& strFields,
					CString& strConstructor)
{
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"ComboBox","Combo");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);
	CString strFlags   =tokenizer.NextToken();

	strFields+=
		"    private ComboBox "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new ComboBox();\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n"
		"        this.Controls.Add("+strVariable+");\r\n";
}

void DialogConverter::ConvertListBox(
					Tokenizer& tokenizer,
					CString strTabIndex,
					CString& strFields,
					CString& strConstructor)
{
	CString strControlID=tokenizer.NextToken();
	CString strVariable=ConvertIDToVariableName(strControlID,"ListBox","List");
	CString strLeft    =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_LEFT_FACTOR);
	CString strRight   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_TOP_FACTOR);
	CString strWidth   =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_WIDTH_FACTOR);
	CString strHeight  =tokenizer.NextTokenAdjustedInteger(dDLUS_TO_PIXELS_HEIGHT_FACTOR);
	CString strFlags   =tokenizer.NextToken();

	strFields+=
		"    private ListBox "+strVariable+";\r\n";

	strConstructor+=
		"        \r\n"
		"        "+strVariable+"         =new ListBox();\r\n"
		"        "+strVariable+".Location=new Point("+strLeft+","+strRight+");\r\n"
		"        "+strVariable+".Width   ="+strWidth+";\r\n"
		"        "+strVariable+".Height  ="+strHeight+";\r\n"
		"        "+strVariable+".TabIndex="+strTabIndex+";\r\n";
	
	if(strFlags.Find("LBS_NOINTEGRALHEIGHT")!=-1)
	{
		strConstructor+=
		"        "+strVariable+".IntegralHeight=false;\r\n";
	}

	strConstructor+=
		"        this.Controls.Add("+strVariable+");\r\n";
}

//////////////////////////////////////

CString DialogConverter::ConvertUpperCaseWithUnderscoresToUpperAndLowerCase(
					CString str)
{
	str.MakeLower();

	for(int i=1;i<str.GetLength();i++)
	{
		if(str.GetAt(i-1)=='_')
		{
			char ch=str.GetAt(i);

			str.SetAt(i,ch>='a' && ch<='z'?ch-=32:ch);

			str=str.Left(i-1)+
				str.Right(str.GetLength()-i);
		}
	}
	
	if(i=str.GetLength(),str.GetAt(i-1)=='_')
	{
		str=str.Left(i-1)+
			str.Right(str.GetLength()-i);
	}

	return str;
}

CString DialogConverter::ConvertDialogResourceNameToFormName(
					CString strDialogResourceName)
{
	if(strDialogResourceName.Left(4)=="IDD_")
	{
		strDialogResourceName=strDialogResourceName.Right(strDialogResourceName.GetLength()-4);
	}

	strDialogResourceName=ConvertUpperCaseWithUnderscoresToUpperAndLowerCase(strDialogResourceName);

	char ch=strDialogResourceName.GetAt(0);
	strDialogResourceName.SetAt(0,ch>='a' && ch<='z'?ch-=32:ch);

	if(strDialogResourceName.Right(6)=="Dialog")
	{
		strDialogResourceName=strDialogResourceName.Left(strDialogResourceName.GetLength()-6);
	}

	return strDialogResourceName+"Form";
}

CString DialogConverter::ConvertIDToVariableName(
								CString strControlID,
								CString strType,
								CString strAlternativePossibility)
{
	if(strControlID.Left(4)=="IDC_")
	{
		strControlID=strControlID.Right(strControlID.GetLength()-4);
	}

	if(strControlID.Left(2)=="ID")
	{
		strControlID=strControlID.Right(strControlID.GetLength()-2);
	}

	strControlID=ConvertUpperCaseWithUnderscoresToUpperAndLowerCase(strControlID);

	if(strControlID.Right(strAlternativePossibility.GetLength())==strAlternativePossibility)
	{
		strControlID=strControlID.Left(strControlID.GetLength()-strAlternativePossibility.GetLength());
	}

	if(strControlID.Right(strType.GetLength())!=strType)
	{
		strControlID+=strType;
	}

	return strControlID;
}

//////////////////////////////////////

void DialogConverter::DisplayClassInIDE(
								IApplication* pIApplication,
								CString strSource)
{
	CComPtr<IDispatch> pDisp;
	CComPtr<IApplication> pApplication(pIApplication);

	if(SUCCEEDED(pApplication->get_Documents(&pDisp)))
	{
		CComQIPtr<IDocuments, &IID_IDocuments> pDocuments=pDisp;
		pDisp=NULL;

		if(pDocuments)
		{
			if(SUCCEEDED(pDocuments->Add(_bstr_t("Text"),_variant_t(),&pDisp)))
			{
				CComQIPtr<ITextDocument, &IID_ITextDocument> pDocument=pDisp;
				pDisp=NULL;

				if(pDocument)
				{
					if(SUCCEEDED(pDocument->get_Selection(&pDisp)))
					{
						CComQIPtr<ITextSelection, &IID_ITextSelection> pSelection=pDisp;
						pDisp=NULL;

						if(pSelection)
						{
							pSelection->put_Text(_bstr_t(strSource));
						}
					}
				}
			}
			else
			{
				throw CString("Couldn't open a new file.");
			}
		}
	}
}
